### Resolution/Frame Rate compatibility table for HERO4 Black/Session/Silver

##### HERO4 Black:

VideoResolution |   Frames Per Second (fps) NTSC/PAL |  Field of View (FOV)        | Screen Resolution
----------------|----------------------------------|-----------------------------|-------------------
4K              |  30, 25, 24                      |  Ultra Wide                   |    3840x2160
4K SuperView      |  24                                |  Ultra Wide                   |    3840x2160
2.7K              |  60, 50, 48, 30, 25, 24            |  Ultra Wide, Medium           |    2704x1520
2.7K SuperView  |  30, 25                          |  Ultra Wide                   |    2704x1520
2.7K 4:3          |  30, 25                            |  Ultra Wide                   |    2704x2028
1440p           |  80, 60, 50, 48, 30, 25, 24      |  Ultra Wide                   |    1920x1440
1080p           |  120, 90, 60, 50, 48, 30, 25, 24 |  Ultra Wide, Medium, Narrow |    1920x1080
1080p SuperView |    80, 60, 50, 48, 30, 25, 24        |  Ultra Wide                   |    1920x1080
960p              |  120, 60, 50                       |  Ultra Wide                   |    1280x960
720p              |  240, 120, 60, 50, 30 , 25       |  Ultra Wide, Medium, Narrow |    1280x720
720p SuperView  |  120, 60, 50                     |  Ultra Wide                   |    1280x720
WVGA              |  240                               |  Ultra Wide                   |    848x480

##### HERO4 Session:                                                                     

VideoResolution |   Frames per Second (fps) NTSC/PAL | Field of View (FOV)         |  Screen Resolution
----------------|----------------------------------|-----------------------------|-------------------
1440p           |  30, 25                          | Ultra Wide                    |     1920 x 1440
1080p           |  60, 50, 30, 25                  | Ultra Wide, Medium            |     1920 x 1080
1080p SuperView |   48, 30, 25                       | Ultra Wide                  |     1920 x 1080
960p              |  60, 50, 30, 25                    | Ultra Wide                    |     1280 x 960
720p              |  100, 60, 50, 30, 25               | Ultra Wide, Medium            |     1280 x 720
720p SuperView  |  60, 50, 30, 25                  | Ultra Wide                    |     1280 x 720
WVGA              |  120, 100                        | Ultra Wide                  |     848 x 480

##### HERO4 Silver:

VideoResolution |   Frames Per Second (fps) NTSC/PAL | Field of View (FOV)         |  Screen Resolution
----------------|----------------------------------|-----------------------------|-------------------
4K              | 15, 12.5                         | Ultra Wide                    |    3840x2160
2.7K              | 30, 25, 24                       | Ultra Wide, Medium          |    2704x1520
1440p           | 48, 30, 25, 24                     | Ultra Wide                  |    1920x1440
1080p           | 60, 50, 48, 30, 25, 24             | Ultra Wide, Medium, Narrow  |    1920x1080
1080p SuperView | 60, 50, 48, 30, 25, 24             | Ultra Wide                  |    1920x1080
960p              | 100, 60, 50                        | Ultra Wide                    |    1280x960
720p              | 120, 60, 50, 30, 25                | Ultra Wide, Medium, Narrow  |    1280x720
720p SuperView  | 100, 60, 50                      | Ultra Wide                    |    1280x720
WVGA              | 240                                | Ultra Wide                    |    848x480






##### HERO5 Black:

VideoResolution |  FPS NTSC/PAL | FOV
----------------|-----------------
4K              |  30/25        |  Wide
                |  24           |  SuperView, Wide
2.7K            |  60/50        |  Wide, Medium, Linear
                |  48           |  Wide, Medium, Linear
                |  30/25        |  SuperView, Wide, Medium, Linear
                |  24           |  Wide, Medium, Linear
2.7K 4:3        |  30/25        |  Wide
1440            |  80           |  Wide
                |  60/50        |  Wide
                |  48           |  Wide
                |  30/25        |  Wide
                |  24           |  Wide
1080            |  120          |  Wide, Narrow
                |  90           |  Wide
                |  80           |  SuperView
                |  60/50        |  SuperView, Wide, Medium, Linear, Narrow
                |  48           |  SuperView, Wide, Medium, Linear, Narrow
                |  30/25        |  SuperView, Wide, Medium, Linear, Narrow
                |  24           |  SuperView, Wide, Medium, Linear, Narrow
960             |  120          |  Wide
                |  60/50        |  Wide
720             |  240          |  Narrow
                |  120          |  SuperView, Wide, Medium, Narrow
                |  100          |  SuperView
                |  60/50        |  SuperView, Wide, Medium, Narrow
                |  30/25        |  Wide, Medium, Narrow
480             |  240          |  Wide


                
